## lua-sandbox-extensions 0~git20161128

=== CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(luasandbox-extensions LANGUAGES NONE)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
if(WIN32)
  set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_BINDIR})
endif()
set(CMAKE_INSTALL_PREFIX "")
set(CMAKE_SHARED_LIBRARY_PREFIX "")
set(PACKAGE_PREFIX luasandbox)

if(LUA51) # build against installed lua 5.1
    find_package(Lua51)
    set(INSTALL_MODULE_PATH ${CMAKE_INSTALL_LIBDIR}/lua)
    set(INSTALL_IOMODULE_PATH ${CMAKE_INSTALL_LIBDIR}/lua)
    set(INSTALL_SANDBOX_PATH ${CMAKE_INSTALL_DATAROOTDIR}/lua)
    set(PACKAGE_PREFIX lua)
    if(WIN32)
        string(REPLACE "\\" "\\\\" TEST_MODULE_PATH "${CMAKE_BINARY_DIR}\\install\\${CMAKE_INSTALL_LIBDIR}\\${PACKAGE_PREFIX}\\?.lua")
        string(REGEX REPLACE "\\.lua$" ".dll" TEST_MODULE_CPATH ${TEST_MODULE_PATH})
    else()
        set(TEST_MODULE_PATH "${CMAKE_BINARY_DIR}/install/${CMAKE_INSTALL_LIBDIR}/${PACKAGE_PREFIX}/?.lua")
        string(REGEX REPLACE "\\.lua$" ".so" TEST_MODULE_CPATH ${TEST_MODULE_PATH})
    endif()
else() # lua_sandbox build
    find_package(luasandbox 1.2.1 REQUIRED CONFIG)
    set(LUA_LIBRARIES ${LUASANDBOX_LIBRARIES})
    set(LUA_INCLUDE_DIR ${LUASANDBOX_INCLUDE_DIR}/luasandbox)
    set(INSTALL_MODULE_PATH ${CMAKE_INSTALL_LIBDIR}/luasandbox/modules)
    set(INSTALL_IOMODULE_PATH ${CMAKE_INSTALL_LIBDIR}/luasandbox/io_modules)
    set(INSTALL_SANDBOX_PATH ${CMAKE_INSTALL_DATAROOTDIR}/luasandbox/sandboxes)
    add_definitions(-DLUA_SANDBOX)
    if(WIN32)
        string(REPLACE "\\" "\\\\" TEST_MODULE_PATH "${CMAKE_BINARY_DIR}\\install\\${CMAKE_INSTALL_LIBDIR}\\${PACKAGE_PREFIX}\\modules\\?.lua")
        string(REGEX REPLACE "\\.lua$" ".dll" TEST_MODULE_CPATH ${TEST_MODULE_PATH})
        string(REGEX REPLACE "\\modules\\\\?" "\\io_modules\\?" TEST_IOMODULE_PATH ${TEST_MODULE_PATH})
        string(REGEX REPLACE "\\.lua$" ".dll" TEST_IOMODULE_CPATH ${TEST_IOMODULE_PATH})
    else()
        set(TEST_MODULE_PATH "${CMAKE_BINARY_DIR}/install/${CMAKE_INSTALL_LIBDIR}/${PACKAGE_PREFIX}/modules/?.lua")
        string(REGEX REPLACE "\\.lua$" ".so" TEST_MODULE_CPATH ${TEST_MODULE_PATH})
        string(REGEX REPLACE "/modules/\\?" "/io_modules/?" TEST_IOMODULE_PATH ${TEST_MODULE_PATH})
        string(REGEX REPLACE "\\.lua$" ".so" TEST_IOMODULE_CPATH ${TEST_IOMODULE_PATH})
    endif()
    configure_file(${CMAKE_SOURCE_DIR}/cmake/test_module.in.h ${CMAKE_BINARY_DIR}/test_module.h)
endif()

include(CTest)
configure_file(${CMAKE_SOURCE_DIR}/cmake/CTestCustom.in.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake)

include(ExternalProject)
set(EP_CMAKE_ARGS
-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/install
-DINSTALL_MODULE_PATH=${INSTALL_MODULE_PATH}
-DINSTALL_IOMODULE_PATH=${INSTALL_IOMODULE_PATH}
-DINSTALL_SANDBOX_PATH=${INSTALL_SANDBOX_PATH}
-DLUA51=${LUA51}
--no-warn-unused-cli)

set(extensions 
bloom_filter
circular_buffer
cjson
compat
cuckoo_filter
elasticsearch
geoip
heka
hyperloglog
kafka
lfs
lpeg
lsb
moz_telemetry
openssl
parquet
postgres
rjson
sax
snappy
socket
ssl
struct
syslog
systemd
zlib
)

foreach(ext IN LISTS extensions)
  if(ENABLE_ALL_EXT)
    option(EXT_${ext} "include extension ${ext}" ON)
  else()
    option(EXT_${ext} "include extension ${ext}" OFF)
  endif()
endforeach()

if(NOT CPACK_GENERATOR)
  if(WIN32)
     set(CPACK_GENERATER ZIP)
  else()
     set(CPACK_GENERATOR TGZ)
  endif()
endif()

set(PACKAGE_COMMANDS "")
foreach(ext IN LISTS extensions)
  if (EXT_${ext})
      add_subdirectory(${ext})
      set(PACKAGE_COMMANDS ${PACKAGE_COMMANDS} COMMAND cpack -G ${CPACK_GENERATOR} --config ${ext}.cpack)
      message("${ext}\tENABLED")
  else()
      message("${ext}\tDISABLED")
  endif()
endforeach()

if(PACKAGE_COMMANDS STREQUAL "")
   message(FATAL_ERROR "No extensions were specificed use -DENABLE_ALL_EXT=true or specify any of the following -DEXT_[${extensions}]=on ...")
endif()

add_custom_target(packages ${PACKAGE_COMMANDS})
add_custom_target(docs lua gen_gh_pages.lua WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== bloom_filter/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0)
project(bloom-filter VERSION 1.0.0 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Lua bloom filter module (membership test)")
set(MODULE_SRCS bloom_filter.c ../common/xxhash.c bloom_filter.def)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "luasandbox (>= 1.0)")
include(sandbox_module)

=== circular_buffer/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0)
project(circular-buffer VERSION 1.0.2 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Lua circular buffer module (in-memory time series data store)")
set(MODULE_SRCS circular_buffer.c circular_buffer.def)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "luasandbox (>= 1.0), luasandbox-lpeg (>= 1.0), ${PACKAGE_PREFIX}-cjson (>= 2.1)")
string(REGEX REPLACE "[()]" "" CPACK_RPM_PACKAGE_REQUIRES ${CPACK_DEBIAN_PACKAGE_DEPENDS})
include(sandbox_module)

=== cjson/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
project(cjson LANGUAGES C)

externalproject_add(
    ep_cjson
    GIT_REPOSITORY https://github.com/trink/lua-cjson.git
    GIT_TAG b24f724a4982531e392a88679b3783fdc5361c5d
    CMAKE_ARGS ${EP_CMAKE_ARGS}
    UPDATE_COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt.${PROJECT_NAME} <SOURCE_DIR>/CMakeLists.txt
)
externalproject_add_step(ep_cjson copy_cpack 
COMMAND ${CMAKE_COMMAND} -E copy <BINARY_DIR>/${PROJECT_NAME}.cpack ${CMAKE_BINARY_DIR}
DEPENDEES install)
include(sandbox_ep_test)

=== compat/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
project(compat LANGUAGES NONE)

externalproject_add(
    ep_compat
    GIT_REPOSITORY https://github.com/keplerproject/lua-compat-5.2.git
    GIT_TAG ad22f7e8a6ee2445f3085b572ba925d2561c7359
    CMAKE_ARGS ${EP_CMAKE_ARGS}
    UPDATE_COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt.${PROJECT_NAME} <SOURCE_DIR>/CMakeLists.txt
)
externalproject_add_step(ep_compat copy_cpack
COMMAND ${CMAKE_COMMAND} -E copy <BINARY_DIR>/${PROJECT_NAME}.cpack ${CMAKE_BINARY_DIR}
DEPENDEES install)

=== cuckoo_filter/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0)
project(cuckoo-filter VERSION 1.0.0 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Lua cuckoo filter module (membership test with deletion support)")
set(MODULE_SRCS cuckoo_filter.c ../common/xxhash.c cuckoo_filter.def)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "luasandbox (>= 1.0)")
include(sandbox_module)

=== elasticsearch/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0)
project(elasticsearch VERSION 1.0.3 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Elasticsearch encoders and outputs")
set(MODULE_DEPENDENCIES heka_copy_tests rjson ep_cjson ep_socket) # fail the build if all the required modules were not specified
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${PACKAGE_PREFIX}-heka (>= 1.0), ${PACKAGE_PREFIX}-rjson (>= 1.0), ${PACKAGE_PREFIX}-cjson (>= 2.1), ${PACKAGE_PREFIX}-socket (>= 3.0)")
string(REGEX REPLACE "[()]" "" CPACK_RPM_PACKAGE_REQUIRES ${CPACK_DEBIAN_PACKAGE_DEPENDS})
include(sandbox_module)

=== geoip/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
project(geoip LANGUAGES NONE)

externalproject_add(
    ep_geoip
    GIT_REPOSITORY https://github.com/agladysh/lua-geoip.git
    GIT_TAG a07d261d8a2c7ff854fe6cd72cb8c2e16ec638ff
    CMAKE_ARGS ${EP_CMAKE_ARGS}
    UPDATE_COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt.${PROJECT_NAME} <SOURCE_DIR>/CMakeLists.txt
)
externalproject_add_step(ep_geoip copy_cpack 
COMMAND ${CMAKE_COMMAND} -E copy <BINARY_DIR>/${PROJECT_NAME}.cpack ${CMAKE_BINARY_DIR}
DEPENDEES install)

=== heka/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0)
project(heka VERSION 1.1.5 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Utility modules for Heka sandboxes")
set(MODULE_DEPENDENCIES ep_cjson) # postgres is conditionaly so don't make it a dependency
set(CPACK_DEBIAN_PACKAGE_DEPENDS "luasandbox (>= 1.2), ${PACKAGE_PREFIX}-cjson (>= 2.1)")
string(REGEX REPLACE "[()]" "" CPACK_RPM_PACKAGE_REQUIRES ${CPACK_DEBIAN_PACKAGE_DEPENDS})
include(sandbox_module)

=== hyperloglog/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0)
project(hyperloglog VERSION 1.0.0 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Lua hyperloglog module (distinct count)")
set(MODULE_SRCS hyperloglog.c redis_hyperloglog.c hyperloglog.def)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "luasandbox (>= 1.0)")
include(sandbox_module)

=== kafka/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0)
project(kafka VERSION 1.0.5 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Lua Kafka producer/consumer module")

# todo add a more robust kafka check
find_library(LIBRTKAFKA_LIBRARY rdkafka REQUIRED)

set(MODULE_SRCS kafka.c kafka.def)
set(INSTALL_MODULE_PATH ${INSTALL_IOMODULE_PATH})
set(INTEGRATION_TEST TRUE)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "luasandbox (>= 1.2), librdkafka-dev (>= 0.9)")
include(sandbox_module)
target_link_libraries(kafka ${LIBRTKAFKA_LIBRARY})

=== lfs/CMakeLists.txt ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
project(lfs LANGUAGES NONE)

externalproject_add(
    ep_lfs
    GIT_REPOSITORY https://github.com/keplerproject/luafilesystem.git
    GIT_TAG 50919ed69ff64df51d8d586d00834fde3e901785
    CMAKE_ARGS ${EP_CMAKE_ARGS}
    UPDATE_COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt.${PROJECT_NAME} <SOURCE_DIR>/CMakeLists.txt
)
externalproject_add_step(ep_lfs copy_cpack 
COMMAND ${CMAKE_COMMAND} -E copy <BINARY_DIR>/${PROJECT_NAME}.cpack ${CMAKE_BINARY_DIR}
DEPENDEES install)

=== debian/changelog ===
lua-sandbox-extensions (0~git20161128-1) unstable; urgency=medium

  * Initial release (Closes: #847952)

 -- Sophie Brun <sophie@freexian.com>  Fri, 02 Dec 2016 14:59:59 +0100

=== debian/control ===
Source: lua-sandbox-extensions
Section: interpreters
Priority: optional
Maintainer: Heka Maintainers <pkg-heka-maint@lists.alioth.debian.org>
Uploaders: Raphaël Hertzog <hertzog@debian.org>, Mathieu Parent <sathieu@debian.org>, Sophie Brun <sophie@freexian.com>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.8
Homepage: https://github.com/mozilla-services/lua_sandbox_extensions
Vcs-Git: https://anonscm.debian.org/git/pkg-heka/lua-sandbox-extensions.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-heka/lua-sandbox-extensions.git

Package: lua-sandbox-extensions
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${lua:Provides}
Suggests: luasandbox-bloom-filter, luasandbox-circular-buffer, luasandbox-cjson, luasandbox-compat, luasandbox-cuckoo-filter, luasandbox-elasticsearch, luasandbox-geoip, luasandbox-heka, luasandbox-hyperloglog,luasandbox-kafka, luasandbox-lfs, luasandbox-lpeg, luasandbox-lsb, luasandbox-moz-telemetry, luasandbox-openssl, luasandbox-parquet, luasandbox-postgres, luasandbox-rjson, luasandbox-sax, luasandbox-snappy, luasandbox-socket, luasandbox-ssl, luasandbox-struct, luasandbox-syslog, luasandbox-systemd, luasandbox-zlib
XB-Lua-Versions: ${lua:Versions}
Description: Extension sandboxes and modules for Lua Sandbox
 This package aggregates multiple lua extensions targeted for the
 "luasandbox" Lua implementation. Only the luasandbox specific files from this
 package are shipped. The standard lua-* packages will be used to build the
 compiled extensions.

Package: lua-sandbox-extensions-dev
Section: libdevel
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Depends: lua-sandbox-extensions (= ${binary:Version}), ${misc:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: Extension sandboxes and modules for Lua Sandbox
 This package contains the development files of the lua-sandbox-extensions
 library, useful to create a statically linked binary (like a C application or
 a standalone Lua interpreter).
 .
 Documentation is also shipped within this package.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	# Don't run cmake, we just want to copy .lua files for now

override_dh_install:
	dh_install
	for f in $$(find . -name "*.lua" | grep -v /tests/ | grep -v gen_gh); do \
	    install -m 644 -D $$f debian/lua-sandbox-extensions/usr/share/luasandbox/$${f#./*/}; \
	done

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%lua-sandbox-extensions-$1.tar.gz%" \
   https://github.com/mozilla-services/lua_sandbox-extensions/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
